package com.ynet.life.sujrb.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.log.GENELog;
import com.ynet.life.base.LifeAction;
import java.util.Calendar;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TimeZone;

/* loaded from: com_ynet_life_sujrb_action.jar:com/ynet/life/sujrb/action/ElectronCertificateNoAction.class */
public class ElectronCertificateNoAction extends LifeAction {
    private String certificateNo = "";
    private String delim = "";
    private int length = 12;
    private String scope = "0-9|a-k|m-n|p-z";
    private static final Random RANDOM = new Random();

    public void setCertificateNo(String certificateNo) {
        this.certificateNo = certificateNo;
    }

    public String execute(Context context) throws GENEException {
        String strMonth;
        String strDay;
        try {
            Calendar dt = Calendar.getInstance(TimeZone.getDefault());
            String current_year = new StringBuilder(String.valueOf(dt.get(1))).toString();
            int i = dt.get(2) + 1;
            if (i < 10) {
                strMonth = "0".concat(String.valueOf(i));
            } else {
                strMonth = String.valueOf(i);
            }
            int i2 = dt.get(5);
            if (i2 < 10) {
                strDay = "0".concat(String.valueOf(i2));
            } else {
                strDay = String.valueOf(i2);
            }
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "strDay==========".concat(String.valueOf(strDay)));
            String randomStr = random(this.length, this.scope, this.delim);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "随机12位值".concat(String.valueOf(randomStr)));
            String certificateno = String.valueOf(current_year) + strMonth + strDay + randomStr;
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "返回的电子回单号为".concat(String.valueOf(certificateno)));
            context.setDataValue(this.certificateNo, certificateno);
            return "0";
        } catch (Exception e) {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, e.toString());
            return "-1";
        }
    }

    private static String random(int count, String[][] scopes, String delim, Random random) {
        int start;
        int end;
        if (count == 0) {
            return "";
        }
        if (count < 0) {
            throw new IllegalArgumentException("Requested random string length " + count + " is less than 0.");
        }
        int size = scopes.length;
        boolean letters = false;
        boolean numbers = false;
        for (String[] scope : scopes) {
            String s1 = scope[0];
            String s2 = scope[1];
            if (letters && numbers) {
                break;
            }
            if (s1.length() > 1 || s2.length() > 1) {
                numbers = true;
            } else {
                char c1 = s1.charAt(0);
                char c2 = s2.charAt(0);
                if (!numbers && ((c1 >= '0' && c1 <= '9') || (c2 >= '0' && c2 <= '9'))) {
                    numbers = true;
                }
                if (!letters && ((c1 >= 'A' && c1 <= 'z') || (c2 >= 'A' && c2 <= 'z'))) {
                    letters = true;
                }
            }
        }
        if (!letters && !numbers) {
            throw new IllegalArgumentException("取值范围错误。");
        }
        StringBuffer buffer = new StringBuffer();
        while (true) {
            int i = count;
            count--;
            if (i != 0) {
                int index = random.nextInt(size);
                boolean isNumber = false;
                try {
                    start = Integer.parseInt(scopes[index][0]);
                    isNumber = true;
                } catch (NumberFormatException unused) {
                    start = scopes[index][0].charAt(0);
                }
                try {
                    end = Integer.parseInt(scopes[index][1]);
                } catch (NumberFormatException unused2) {
                    end = scopes[index][1].charAt(0);
                }
                int gap = (end - start) + 1;
                int rand = random.nextInt(gap) + start;
                if (!letters || isNumber) {
                    buffer.append(rand);
                    if (delim != null && count > 0) {
                        buffer.append(delim);
                    }
                } else {
                    char ch = (char) rand;
                    if ((letters && numbers && Character.isLetterOrDigit(ch)) || ((letters && Character.isLetter(ch)) || ((numbers && Character.isDigit(ch)) || (!letters && !numbers)))) {
                        buffer.append(ch);
                        if (delim != null && count > 0) {
                            buffer.append(delim);
                        }
                    } else {
                        count++;
                    }
                }
            } else {
                return buffer.toString();
            }
        }
    }

    public static synchronized String random(int count, String scope, String delim) {
        StringTokenizer token = new StringTokenizer(scope, "|");
        int len = token.countTokens();
        String[][] scopes = new String[len][2];
        for (int i = 0; i < len; i++) {
            String s = token.nextToken();
            String c1 = s.substring(0, s.indexOf("-"));
            String c2 = s.substring(s.indexOf("-") + 1, s.length());
            if (c1.length() > 1 || c2.length() > 1) {
                try {
                    if (Integer.parseInt(c1) > Integer.parseInt(c2)) {
                        c2 = c1;
                        c1 = c2;
                    }
                } catch (NumberFormatException unused) {
                    throw new IllegalArgumentException("取值范围设定错误 " + c1 + " 或 " + c2 + " 不是一个有效地范围值.");
                }
            } else if (c1.charAt(0) > c2.charAt(0)) {
                c2 = c1;
                c1 = c2;
            }
            scopes[i][0] = c1;
            scopes[i][1] = c2;
        }
        return random(count, scopes, delim, RANDOM);
    }
}
